<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Cloning</TITLE>
<link href="suif1_86.html" rel=Next>
<link href="suif1_84.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_84.html">previous</A>, <A HREF="suif1_86.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC85" HREF="suif1_toc.html#TOC85">Replicating Trees and Instructions</A></H1>
<P>
<A NAME="IDX621"></A>
<A NAME="IDX622"></A>

</P>
<P>
Many SUIF programs need to duplicate parts of abstract syntax trees or
expression trees.  For example, loop transformations such as unrolling
and peeling require copies of the loop bodies, and entire procedures
must be copied to implement procedure inlining.  Because code
replication can be quite complicated in SUIF, it is handled in the
library by the <STRONG>cloning</STRONG> methods.

</P>
<P>
<A NAME="IDX623"></A>
<A NAME="IDX624"></A>
<A NAME="IDX625"></A>
<A NAME="IDX626"></A>
<A NAME="IDX627"></A>
<A NAME="IDX628"></A>
<A NAME="IDX629"></A>
<A NAME="IDX630"></A>
<A NAME="IDX631"></A>
<A NAME="IDX632"></A>
Several different kinds of SUIF objects can be cloned.  The
<CODE>tree_node</CODE>, <CODE>tree_node_list</CODE>, <CODE>instruction</CODE>, and
<CODE>operand</CODE> classes have <CODE>clone</CODE> methods.  The various derived
<CODE>tree_node</CODE> classes also have wrapper methods to cast the result of
the base class <CODE>clone</CODE> method to the appropriate pointer types.
When an object is cloned, everything within it is recursively cloned.
In addition to the child nodes and instructions, this includes symbol
tables and the types and symbols within them.  All of the known
references to cloned objects (including those in registered annotations)
are updated.

</P>
<P>
The complexity of cloning is primarily due to SUIF's scope rules.  The
code being copied may reference symbols and types that are not visible
in the scope where the copy will be used.  Thus the cloning process is
divided into three steps:

</P>

<OL>
<LI>

The code to be copied is scanned for references to symbols and types
that are not visible in the specified destination scope.  These are
referred to as <STRONG>exposed references</STRONG>.

<LI>

The exposed references are resolved in the symbol table for the
destination scope.  New variables are created to replace the exposed
variables.  Types are usually moved up in the symbol table hierarchy so
that they are visible in both the source and destination scopes.

<LI>

The code is actually copied.  Symbol tables nested within the code are
copied and references to them and their contents are updated to use the
copies.  Similarly, the exposed references are replaced with references
to any new symbols or types that were created in the previous step.
</OL>

<P>
Each of these steps is described in more detail below.  The methods that
perform the individual steps are available to users who need more
control over the cloning process.  For example, you may want to insert
code to initialize new variables that are created in the destination
scope due to exposed references.  The cloning methods can also be used
to replace references to particular symbols or types without actually
copying anything.

</P>
<P>
<A NAME="IDX633"></A>
The <CODE>replacements</CODE> structure is used throughout the cloning process
to keep track of exposed references and objects that have been replaced.
This structure includes lists of symbols, types, variable definitions,
symbol tables, and instructions.  For each kind of object, there are two
lists.  Except in intermediate steps, these lists should be the same
length.  An entry on the first list refers to an object in the original
code and the corresponding entry on the second list is a new object that
has been created to replace the original.

</P>

<UL>
<LI><A HREF="suif1_86.html#SEC86">Finding Exposed References</A>: Finding things not visible at the destination.
<LI><A HREF="suif1_87.html#SEC87">Resolving Exposed References</A>: Creating replacement objects.
<LI><A HREF="suif1_88.html#SEC88">Copying the Objects</A>: Copying the code and updating references.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_84.html">previous</A>, <A HREF="suif1_86.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
